// Taken from:

// Getting started with JOGL (OpenGL bindings for Java) in Eclipse
// https://solarianprogrammer.com/2014/12/08/getting-started-jogl-java-opengl-eclipse/#JOGL

package openGL;

import com.jogamp.opengl.GL4;
import com.jogamp.opengl.GLAutoDrawable;
import com.jogamp.opengl.GLEventListener;

import javax.swing.JFrame;

import com.jogamp.opengl.GLCapabilities;
import com.jogamp.opengl.GLProfile;
import com.jogamp.opengl.awt.GLCanvas;

public class Game extends JFrame implements GLEventListener {
    private static final long serialVersionUID = 1L; 
    final private int width = 800;     
    final private int height = 600;
    
     public Game() {
         super("Minimal OpenGL");
         GLProfile profile = GLProfile.get(GLProfile.GL4);
         GLCapabilities capabilities = new GLCapabilities(profile);

         GLCanvas canvas = new GLCanvas(capabilities);
         canvas.addGLEventListener(this);
 
        this.setName("Minimal OpenGL");
        this.getContentPane().add(canvas);
 
         this.setSize(width, height);
         this.setLocationRelativeTo(null);
         this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
         this.setVisible(true);
         this.setResizable(false);
         canvas.requestFocusInWindow();
     }

public void display(GLAutoDrawable drawable) {
	GL4 gl = drawable.getGL().getGL4();
	 gl.glClear(GL4.GL_COLOR_BUFFER_BIT | GL4.GL_DEPTH_BUFFER_BIT);
	        // call your draw code here
	 gl.glFlush();
	
}

public void dispose(GLAutoDrawable drawable) {
	// TODO Auto-generated method stub
	
}

public void init(GLAutoDrawable drawable) {
	GL4 gl = drawable.getGL().getGL4();
	gl.glClearColor(0.392f, 0.584f, 0.929f, 1.0f);
	
}

public void reshape(GLAutoDrawable drawable, int arg1, int arg2, int arg3, int arg4) {
	// TODO Auto-generated method stub
	
}

}
